import cPickle
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.mlab as mlab
import matplotlib
from matplotlib.ticker import FuncFormatter

import pylab

def printtime(mins,pos=0):
    h = float(mins)/float(60)
    hint = int(h)
    m = (h-hint)*60
    mint = int(m)
    s = (m-mint)*60
    sint = int(s)
    #return str(hint)+":"+str(mint)+":"+str(sint) 
    return "%d:%02d:%02d"%(hint,mint,sint)
if __name__ == "__main__":  
    timelist = cPickle.load(open('time_list2_times.p', 'rb'))
    print " loaded ", len(timelist)," times from disk"
    #print printtime(max(timelist))
    #print printtime( timelist[len(timelist)-1] ) 
    #print printtime(min(timelist))
    #n=0
    #for t in timelist:
    #    if t > timelist[len(timelist)-1]:
    #        print n," : ",t,"    ", printtime(t)
    #    n=n+1
    #exit()
    #for t in timelist:
    #    printtime(t)
    
    fig = plt.figure()
    ax = fig.add_subplot(111)
    # histogram
    n, bins, patches = ax.hist( timelist , 100, normed=0, facecolor='green', alpha=0.75)
    ax.set_title('Helsinki City Marathon, 14.8.2010')
    ax.set_xlabel('Time')
    ax.set_ylabel('N')
    mu = np.average(timelist)
    std = np.std(timelist)
    
    pylab.text(5.2*60, 130, 'N=%i\nmu=%s\nsigma=%s'%(len(timelist), printtime(mu), printtime(std)))
    
    mux=[mu , mu]
    muy=[0 , 450]
    splus=[mu+std , mu+std]
    sminus=[mu-std , mu-std]
    plt.plot(mux,muy, 'r--')
    plt.plot(splus,muy, 'r--')
    plt.plot(sminus,muy, 'r--')
    locs = []
    tloc = 120
    locs.append(tloc)
    while tloc<7*60:
        tloc=tloc+15
        locs.append(tloc)
        
    ax.xaxis.set_major_locator( matplotlib.ticker.FixedLocator( locs )  )
    
    
    formatter = FuncFormatter(printtime)
    ax.xaxis.set_major_formatter(formatter)
    fig.autofmt_xdate(rotation=90)
    ax.set_xlim(2.25*60, 6.5*60)
    ax.set_ylim(0, 160)
    ax.grid(True)

    plt.show()
