import cPickle
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.mlab as mlab
import matplotlib
from matplotlib.ticker import FuncFormatter
import pylab

def printtime(mins,pos=0):
    h = float(mins)/float(60)
    hint = int(h)
    m = (h-hint)*60
    mint = int(m)
    s = (m-mint)*60
    sint = int(s)
    return str(hint)+":"+str(mint)+":"+str(sint) 

if __name__ == "__main__":  
    serie =      ["HCM_0_100", "HCM_M_18", "HCM_M_40", "HCM_M_45", "HCM_M_50", "HCM_M_55", "HCM_M_60", "HCM_M_65", "HCM_M_70",
                    "HCM_N_18", "HCM_N_35", "HCM_N_40", "HCM_N_45", "HCM_N_50", "HCM_N_55", "HCM_N_60"]
    n_serie = 16
    datafile = cPickle.load(open( serie[n_serie], 'rb'))
    print " loaded ", len(datafile)," times from disk"
    timelist=datafile
    
    fig = plt.figure()
    ax = fig.add_subplot(111)
    # histogram
    n, bins, patches = ax.hist( timelist , max( 20 , len(datafile)/10 ) , normed=0, facecolor='green', alpha=0.75)
    ax.set_title('Helsinki City Marathon, 14.8.2010')
    ax.set_xlabel('Time')
    ax.set_ylabel('N')
    mu = np.average(timelist)
    std = np.std(timelist)
    
    pylab.text(5.3*60, 0.5*max(n), '%s\nN=%i\nmu=%s\nsigma=%s'%(serie[n_serie],len(timelist), printtime(mu), printtime(std)))
    
    mux=[mu , mu]
    muy=[0 , 450]
    splus=[mu+std , mu+std]
    sminus=[mu-std , mu-std]
    plt.plot(mux,muy, 'r--')
    plt.plot(splus,muy, 'r--')
    plt.plot(sminus,muy, 'r--')
    locs = []
    tloc = 120
    locs.append(tloc)
    while tloc<7*60:
        tloc=tloc+15
        locs.append(tloc)
        
    #locs =[100, 200, 300]
    ax.xaxis.set_major_locator( matplotlib.ticker.FixedLocator( locs )  )
    
    
    formatter = FuncFormatter(printtime)
    ax.xaxis.set_major_formatter(formatter)
    fig.autofmt_xdate(rotation=90)
    ax.set_xlim(2*60, 6.5*60)
    ax.set_ylim(0, 1.1*max(n))
    ax.grid(True)
    plt.savefig( serie[n_serie]+"_fig.png")
    plt.show()
    #plt.savefig( serie[n_serie]+"_fig.png")
